; SidWine 3 C64 Online Music Competition result pgr
; Tognon Stefano
; (c) 2004 Ice Team
;
; dasm source code

 processor 6502
 ;org 2049

 ;=================================
 ; BASIC startup program
 ;=================================
 ;dc.b $0b,$08,$e8,$03,$9e,"2061",0,0,0
 org 2061

; memory map
; $8001-0dff space for program
; $0e00-1000 free space for sprite and char definitions
; $1000-1fff bitmap color
; $2000-3F40 bitmap definitions
; $4000-5000 copyed chars definitions
; $5000-...  space for program
; $7000-...  sid music
; $9000-...  digi music

CFROM      = $B4
CTO        = $B6

; pointer to current string of text position for scroller
PSTRING  =  $B8 ; $B9

; temp for Sprite Char Definition
SCHARDEF  = $0E00


; sprites x/y postions
XPOS0 = 60
XPOS1 = XPOS0+48
XPOS2 = XPOS1+48
XPOS3 = XPOS2+48
XPOS4 = XPOS3+48
YPOS  = 180

PSPD0 = $0EC0        ; pointer to sprite 0 data
PSPD1 = PSPD0 + 64   ; pointer to sprite 1 data
PSPD2 = PSPD1 + 64   ; pointer to sprite 2 data
PSPD3 = PSPD2 + 64   ; pointer to sprite 3 data
PSPD4 = PSPD3 + 64   ; pointer to sprite 4 data

RASTER0 = 0



SCREEN     = $E544    ; clean the screen
SET_COOR   = $E50C    ; set x/y coord
PUT_CHAR   = $E716    ; put a char in the screen
STRING     = $AB1E    ; put a string

                            ; copy color to screen coord

; copy rom char into ram for sprite scroller

                                  ; transfer characters codes to 16384 14336
      lda  #254
      and  $DC0E
      sta  $DC0E
      lda  #251
      and  $01
      sta  $01
                                  ; set pointers
      lda  #$40
      sta  CTO+1
      lda  #$D0
      sta  CFROM+1
      lda  #0
      sta  CTO
      sta  CFROM
      ldx  #0
copy:                             ; copy the chars
      lda  (CFROM,x)
      sta  (CTO,x)
      inc  CFROM
      inc  CTO
      bne  copy
      inc  CFROM+1
      inc  CTO+1
      lda  CTO+1
      cmp  #$43
      bne  copy
                                  ; restore pcr
      lda  #04
      ora  $01
      sta  $01
      lda  #01
      ora  $DC0E
      sta  $DC0E

      jsr  initSprite
      jsr  initScroll
      jsr  initText


enableGraphics:             ; set pointer for graphics data
      lda  $d018
      ora  #$08
      and  #$f8
      sta  $d018
                            ; enable hires bitmap mode
      lda  $d011
      ora  #$20
      sta  $d011
      lda  $d016
      and  #$EF
      sta  $d016

      ldx #39
iscr1:
N     SET  0
      REPEAT 25
      lda  s2+N*40,x
      sta  $400+N*40,x
N     SET  N+1
      REPEND
      dex
      bmi iscrdone1
      jmp iscr1
iscrdone1:

      lda  #$00
      jsr  $7000
      jsr  $9000

; install raster interrupt for music and scroller
initraster:
      sei
      lda  #<raster0
      sta  $0314
      lda  #>raster0
      sta  $0315
      lda  #RASTER0                    ;Set low bits of raster
      sta  $d012                       ;position
      lda  $d011
      and  #$7f                        ;Set high bit of raster
      sta  $d011                       ;position (0)
      lda  #$7f                        ;Set timer interrupt off
      sta  $dc0d

      ;lda #$81
      ;ldx #$01
      ;sta $dd0d
      ;stx $dd0e

      lda  #$01                        ;Set raster interrupt on
      sta  $d01a
      lda  $dc0d                       ;Acknowledge timer interrupt
      cli

      jsr changeText
aaa:  jsr  key
      lda  timer
      bne  aaa

      jsr changeText
      jmp aaa

raster0:
      inc  $d019
      inc  timer

      jsr  $7003
      jsr  $9003

      jsr madeScroll

go_exit:
      jmp  $ea81

;=================================
; Init sprites position for soft
; sprite scroller
;=================================
initSprite:
      lda  #XPOS0                 ; set x positions for sprites
      sta  $D000
      lda  #XPOS1
      sta  $D002
      lda  #XPOS2
      sta  $D004
      lda  #XPOS3
      sta  $D006
      lda  #XPOS4
      sta  $D008

      lda  #YPOS                  ; set y positions for sprites
      sta  $D001
      sta  $D003
      sta  $D005
      sta  $D007
      sta  $D009

      lda  #$00                   ; high positions of sprites x are 0
      sta  $D010

      lda  #((PSPD0)/64)          ; set pointer to sprites definitions
      sta  $800-8
      lda  #((PSPD1)/64)
      sta  $800-7
      lda  #((PSPD2)/64)
      sta  $800-6
      lda  #((PSPD3)/64)
      sta  $800-5
      lda  #((PSPD4)/64)
      sta  $800-4

      lda  #0                      ; clear the ram where there is sprite definitions
      ldx  #255
loopC:
      sta  $0E00,x
      dex
      bne  loopC
      sta  $0E0

      lda  #0                      ; set sprite color
      sta  $D027
      sta  $D028
      sta  $D029
      sta  $D02A
      sta  $D02B

      lda  #$1F
      sta  $D017                  ; sprites 0..4 are expanded in y
      sta  $D01D                  ; and x
      sta  $D015                  ; enable sprites

      rts

;=================================
; Init scroll
;=================================
initScroll:
      lda  #<ScrollText           ; set pointer to start of scroller string
      sta  PSTRING
      lda  #>ScrollText
      sta  PSTRING+1

      lda  #1                     ; no char already in show
      sta  pos+1
      rts

;=================================
; Made a scroll of one bit to sx
;=================================
madeScroll:
      dec  pos+1
pos:
      lda  #8
      bne  scrollSx

nextChar:
      ldy  #0
      lda  (PSTRING),y
      beq  initScroll             ; if 0, the string must restart

      cmp  #63
      bmi  noSub
      sec
      sbc  #64

noSub:
      clc
      rol
      rol
      rol                         ; char*8=index for charset
      sta  pos2+1
      bcc  skip

      inc  pos2+2                 ; fix high value
skip:
      ldx  #7
pos2:
      lda  $4000,x
      sta  SCHARDEF,x             ; store in temp Sprite Char Definition
      dex
      bpl  pos2

      lda  #$40                   ; fix high for next pass
      sta  pos2+2

      inc  PSTRING                ; increase pointer in scroller string
      bne  skip2

      inc  PSTRING+1              ; fix high value

skip2:
      lda  #8                     ; we now have 8 bits to show
      sta  pos+1

scrollSx:
      ldy  #8
      ldx  #0

loopS:
      clc
pos3:
      rol  SCHARDEF
      rol  PSPD4+2,x
      rol  PSPD4+1,x
      rol  PSPD4,x

      rol  PSPD3+2,x
      rol  PSPD3+1,x
      rol  PSPD3,x

      rol  PSPD2+2,x
      rol  PSPD2+1,x
      rol  PSPD2,x

      rol  PSPD1+2,x
      rol  PSPD1+1,x
      rol  PSPD1,x

      rol  PSPD0+2,x
      rol  PSPD0+1,x
      rol  PSPD0,x

      inc  pos3+1                 ; increase to next sprite saved char definitions
      txa
      clc
      adc  #3
      tax

      dey
      bne  loopS

      lda  #<SCHARDEF
      sta  pos3+1
      rts

      ; read a char from the queue
key:
      jsr  $FF9F
      jsr  $FFE4
      cmp  #0
      bne  skipExit
Exit:
      rts
skipExit:
      cmp  #65
      bmi  Exit
      cmp  #73
      bpl  Exit
      pha

; disable interrupt
      ldx #0                          ; stop NMI and IRQ interrupts
      stx $d01a
      lda $d019
      sta $d019

      lda #$7f
      sta $dd0d
      lda $dd0d
      lda #8
      sta $dd0e

      cli
      lda  #$31
      sta  $314
      lda  #$EA
      sta  $315
      lda  #$47
      sta  $318
      lda  #$FE
      sta  $319
      sei

      lda #$25
      ldx #$40
      sta $dc04
      stx $dc05
      lda #$81
      ldx #$01
      sta $dc0d
      stx $dc0e

      lda  #0                   ; volume to 0
      sta  $D418

      jsr  disableGraphics
      jsr  SCREEN

; load the needed file
      pla
      sta  nA

                   ; insert the call to load and pgr execute to safe area
      lda  #$20
      sta  $8F00
      lda  #$D5
      sta  $8F01
      lda  #$FF
      sta  $8F02                   ; Load the file
      lda  #$4C
      sta  $8F03
      lda  #$0d
      sta  $8F04
      lda  #$08
      sta  $8F05

      jsr  $FFE7   ; clall
      jsr  $FDA3   ; IOINIT
      jsr  $FF8A   ; restore
      jsr  $FF5B   ; CINT

      lda  #00
      sta  53281
      lda  #00
      sta  53280

      lda  #$01
      ldx  #$08
      ldy  #$01
      jsr  $FFBA                  ; set logical i/o

      lda  #1
      ldx  #<nA
      ldy  #>nA
      jsr  $FFBD                  ; set file name

      lda  #$00
      ldx  #$FF
      ldy  #$FF
      jmp  $8F00

nA: .byte 0


disableGraphics:            ; set pointer for text data
                            ; enable text mode standard
      lda  $d011
      and  #$dF
      sta  $d011

      lda #21
      sta $d018
      lda #8
      sta $d016
      rts

 org $0e00
; free space for sprites
 org $1000

s2:
 .incbin "b2.raw"

  org 8192
 .incbin "b3.raw"

 org $5000

text3:                            ; each 6 rows there are 3 title of music to display
 .incbin "b33.raw"

timer:                            ; increased at each irq
  .byte 00

NUMTAB = 4                        ; number of table to use

curTab:                           ; current table being used
  .byte $00

; tables of pointer to data to copy for music titles
tableLow:
  .byte #<text3
  .byte #<(text3+6*40*8)
  .byte #<(text3+12*40*8)
  .byte #<(text3+18*40*8)  

tableHi:
  .byte #>text3
  .byte #>(text3+6*40*8)
  .byte #>(text3+12*40*8)
  .byte #>(text3+18*40*8)

;=================================
; Init the text title engine
;=================================
initText:
      lda  #$FF
      sta  curTab
      rts

;=================================
; Change the text of music title
;=================================
changeText:
      ldx  curTab
      inx
      cpx  #NUMTAB
      bne  setCur

      ldx  #0                     ; reset to the first
setCur:

      stx  curTab

      lda  tableLow,x             ; set position from where to copy
      sta  CFROM
      lda  tableHi,x
      sta  CFROM+1

      lda  #<(8192+10*40*8)       ; set position from where to paste
      sta  CTO
      lda  #>(8192+10*40*8)
      sta  CTO+1

      ldx  #8
loopCopyE;
      ldy  #0                     ; copy the chars
loopCopy:
      lda  (CFROM),y
      sta  (CTO),y

      dey
      bne  loopCopy

      inc  CFROM+1
      inc  CTO+1
      dex
      bne  loopCopyE

      ldy  #(20*8)
loopCopy2:
      lda  (CFROM),y
      sta  (CTO),y

      dey
      bne  loopCopy2

      lda  (CFROM),y
      sta  (CTO),y
      rts

  .org $7000

  .incbin  mus.bin

; text to scroll (0 terminated)
ScrollText:
 .byte "HELLO EVERYONE AND WELCOME TO THE RESULT OF  *** SIDWINE3 ONLINE MUSIC COMPETITION *** "
 .byte "AN ICE-TEAM PRODUCTION IN 2004.    "
 .byte "YOU CAN SEE THE RESULTS IN THE FLASHING PANEL, BUT IF YOU PREFER "
 .byte "YOU CAN LOOK AT THE README FILE THAT ARE PLACED INTO THIS PACK.  " 
 .byte "I LIKE TO THANKS ALL THE COMPOSERS THAT JOIN THIS COMPO, AND NOW YOU CAN SEE EVEN THEIR NAMES. "
 .byte "BUT ELSE, ALL THE VOTERS: "
 .byte " SLOWHAND   RANDALL    TONY CAVEN    JOHAN JANSSEN    IAN COOG     LUCA     "
 .byte " MATTSID    ASTERION    TURTLE    RAMBONES     HEIN     STEPPE     ZAPAC    " 
 .byte " BUBIS    SHADOW   STEVE AIRPORT     HADES     INSOMNIA   JONBRO   "
 .byte " INNOCENT   JOERG DROEGE      "
 .byte "I HOPE THAT THE TROUBLES WITH THE SITE THAT I HAVE THIS YEAR DID NOT APPEARS ANYMORE.    "
 .byte "NOW THE SCROLLER WILL LOOP AGAIN, SO "
 .byte "REMEMBER TO KEEP SID MUSIC ALIVE FOREVER...............BYE"
 .byte "                                "
 .byte 0

  .org $9000

  .incbin  digi.bin
